## Guides

Mongoose guides provide detailed tutorials on Mongoose's core concepts and
integrating Mongoose with external tools and frameworks.

### Mongoose Core Concepts

* [Schemas](/docs/guide.html)
* [SchemaTypes](/docs/schematypes.html)
* [Connections](/docs/connections.html)
* [Models](/docs/models.html)
* [Documents](/docs/documents.html)
* [Subdocuments](/docs/subdocs.html)
* [Queries](/docs/queries.html)
* [Validation](/docs/validation.html)
* [Middleware](/docs/middleware.html)
* [Populate](/docs/populate.html)
* [Discriminators](/docs/discriminators.html)
* [Plugins](/docs/plugins.html)
* [Faster Mongoose Queries With Lean](/docs/tutorials/lean.html)
* [Query Casting](/docs/tutorials/query_casting.html)
* [findOneAndUpdate](/docs/tutorials/findoneandupdate.html)
* [Getters and Setters](/docs/tutorials/getters-setters.html)
* [Virtuals](/docs/tutorials/virtuals.html)

### Advanced Topics

* [Working with Dates](/docs/tutorials/dates.html)
* [Custom Casting For Built-in Types](/docs/tutorials/custom-casting.html)
* [Custom SchemaTypes](/docs/customschematypes.html)
* [Advanced Schemas](/docs/advanced_schemas.html)

### Integrations

* [Promises](/docs/promises.html)
* [AWS Lambda](/docs/lambda.html)
* [Browser Library](/docs/browser.html)
* [GeoJSON](/docs/geojson.html)
* [Transactions](/docs/transactions.html)
* [MongoDB Driver Deprecation Warnings](/docs/deprecations.html)
* [Testing with Jest](/docs/jest.html)
* [SSL Connections](/docs/tutorials/ssl.html)

### Migration Guides

* [Mongoose 5.x to 6.x](/docs/migrating_to_6.html)
* [Mongoose 4.x to 5.x](/docs/migrating_to_5.html)
* [Mongoose 3.x to 4.x](/docs/migration.html)

